/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.google.appengine.api.datastore.Query;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospException;
import jp.mosp.payroll.dto.MKintaiKeisanDto;

/**
 * M_KINTAIKEISAN(勤怠計算情報)のDAOクラス 。
 */
public class MKintaiKeisanDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * M_KINTAIKEISAN(勤怠計算情報)。
	 */
	public static final String	TABLE			= "M_KINTAIKEISAN";
	
	/**
	 * KEY_1 = KTNEN(給与計算年)。
	 */
	public static final String	KEY_1			= "KTNEN";
	
	// 列名
	/**
	 * KTNEN(給与計算年)。
	 */
	public static final String	COL_KTNEN		= "KTNEN";
	/**
	 * KTTUKI(給与計算月)。
	 */
	public static final String	COL_KTTUKI		= "KTTUKI";
	/**
	 * KSNEN(給与支払年)。
	 */
	public static final String	COL_KSNEN		= "KSNEN";
	/**
	 * KSTUKI(給与支払月)。
	 */
	public static final String	COL_KSTUKI		= "KSTUKI";
	/**
	 * KSHI(給与支払日)。
	 */
	public static final String	COL_KSHI		= "KSHI";
	/**
	 * KKANRYOU(給与完了)。
	 */
	public static final String	COL_KKANRYOU	= "KKANRYOU";
	/**
	 * STNEN(賞与計算年)。
	 */
	public static final String	COL_STNEN		= "STNEN";
	/**
	 * STTUKI(賞与計算月)。
	 */
	public static final String	COL_STTUKI		= "STTUKI";
	/**
	 * SSNEN(賞与支払年)。
	 */
	public static final String	COL_SSNEN		= "SSNEN";
	/**
	 * SSTUKI(賞与支払月)。
	 */
	public static final String	COL_SSTUKI		= "SSTUKI";
	/**
	 * SSHI(賞与支払日)。
	 */
	public static final String	COL_SSHI		= "SSHI";
	/**
	 * SKANRYOU(賞与完了)。
	 */
	public static final String	COL_SKANRYOU	= "SKANRYOU";
	/**
	 * NTNEN(年調計算年)。
	 */
	public static final String	COL_NTNEN		= "NTNEN";
	/**
	 * NKANRYOU(年調完了)。
	 */
	public static final String	COL_NKANRYOU	= "NKANRYOU";
	/**
	 * TTNEN(算定計算年)。
	 */
	public static final String	COL_TTNEN		= "TTNEN";
	/**
	 * TTTUKI(算定計算月)。
	 */
	public static final String	COL_TTTUKI		= "TTTUKI";
	/**
	 * TKANRYOU(算定完了)。
	 */
	public static final String	COL_TKANRYOU	= "TKANRYOU";
	/**
	 * GTNEN(月変計算年)。
	 */
	public static final String	COL_GTNEN		= "GTNEN";
	/**
	 * GTTUKI(月変計算月)。
	 */
	public static final String	COL_GTTUKI		= "GTTUKI";
	/**
	 * GKANRYOU(月変完了)。
	 */
	public static final String	COL_GKANRYOU	= "GKANRYOU";
	

	/**
	 * コンストラクタ
	 */
	public MKintaiKeisanDao() {
		super();
	}
	
	/**
	 * 検索結果取得(DTOのList)
	 * @return List 検索リスト
	 * @throws SQLException SQL例外が発生した場合
	 */
	private List<MKintaiKeisanDto> mappingAll() throws SQLException {
		List<MKintaiKeisanDto> all = new ArrayList<MKintaiKeisanDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)
	 * @return m_kintaikeisanDto m_kintaikeisanレコード
	 * @throws SQLException SQL例外が発生した場合
	 */
	private MKintaiKeisanDto mapping() throws SQLException {
		MKintaiKeisanDto dto = new MKintaiKeisanDto();
		dto.setKTNen(rs.getInt(COL_KTNEN)); //給与計算年
		dto.setKTTuki(rs.getInt(COL_KTTUKI)); //給与計算月
		dto.setKSNen(rs.getInt(COL_KSNEN)); //給与支払年
		dto.setKSTuki(rs.getInt(COL_KSTUKI)); //給与支払月
		dto.setKShi(rs.getInt(COL_KSHI)); //給与支払日
		dto.setKKanryou(rs.getString(COL_KKANRYOU)); //給与完了
		dto.setSTNen(rs.getInt(COL_STNEN)); //賞与計算年
		dto.setSTTuki(rs.getInt(COL_STTUKI)); //賞与計算月
		dto.setSSNen(rs.getInt(COL_STNEN)); //賞与支払年
		dto.setSSTuki(rs.getInt(COL_SSTUKI)); //賞与支払月
		dto.setSSHi(rs.getInt(COL_SSHI)); //賞与支払日
		dto.setSKanryou(rs.getString(COL_SKANRYOU)); //賞与完了
		dto.setNTNen(rs.getInt(COL_NTNEN)); //年調計算年
		dto.setNKanryou(rs.getString(COL_NKANRYOU)); //年調完了
		dto.setTTNen(rs.getInt(COL_TTNEN)); //算定計算年
		dto.setTTTuki(rs.getInt(COL_TTTUKI)); //算定計算月
		dto.setTKanryou(rs.getString(COL_TKANRYOU)); //算定完了
		dto.setGTNen(rs.getInt(COL_GTNEN)); //月変計算年
		dto.setGTTuki(rs.getInt(COL_GTTUKI)); //月変計算月
		dto.setGKanryou(rs.getString(COL_GKANRYOU)); //月変完了
		return dto;
	}
	
	/**
	 * 全データ取得
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			List<?> all = mappingAll();
			return all;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param ktnen 給与計算年(検索キー)
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForKey(String ktnen) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, Integer.parseInt(ktnen));
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param ktnen 給与計算年(検索キー)
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForKey(int ktnen) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, ktnen);
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param ktnen 給与計算年(検索キー)
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForUpdate(String ktnen) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, Integer.parseInt(ktnen));
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param ktnen 給与計算年(検索キー)
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForUpdate(int ktnen) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, ktnen);
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 全データ取得
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForCalc() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()));
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 全データ取得
	 * @return m_kintaikeisanDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public MKintaiKeisanDto findForUpdate() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getForUpdate());
			executeQuery();
			MKintaiKeisanDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param ktnen 検索給与計算年
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String ktnen) throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(COL_KTNEN);
		sb.append(" LIKE ? ");
		this.pob.appendLike(COL_KTNEN);
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, ktnen);
			executeQuery();
			List<?> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException  	MosP例外処理が発生した場合
	 */
	public int insert(MKintaiKeisanDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException  	MosP例外処理が発生した場合
	 */
	public int update(MKintaiKeisanDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getKTNen());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException  	MosP例外処理が発生した場合
	 */
	public int delete(MKintaiKeisanDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getKTNen());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定
	 * @param dto 更新対象DTO
	 * @param isInsert  挿入文フラグ(true：挿入文、false：更新文)
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void setParams(MKintaiKeisanDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getKTNen()); //給与計算年
		setParam(index++, dto.getKTTuki()); //給与計算月
		setParam(index++, dto.getKSNen()); //給与支払年
		setParam(index++, dto.getKSTuki()); //給与支払月
		setParam(index++, dto.getKShi()); //給与支払日
		setParam(index++, dto.getKKanryou()); //給与完了
		setParam(index++, dto.getSTNen()); //賞与計算年
		setParam(index++, dto.getSTTuki()); //賞与計算月
		setParam(index++, dto.getSSNen()); //賞与支払年
		setParam(index++, dto.getSSTuki()); //賞与支払月
		setParam(index++, dto.getSSHi()); //賞与支払日
		setParam(index++, dto.getSKanryou()); //賞与完了
		setParam(index++, dto.getNTNen()); //年調計算年
		setParam(index++, dto.getNKanryou()); //年調完了
		setParam(index++, dto.getTTNen()); //算定計算年
		setParam(index++, dto.getTTTuki()); //算定計算月
		setParam(index++, dto.getTKanryou()); //算定完了
		setParam(index++, dto.getGTNen()); //月変計算年
		setParam(index++, dto.getGTTuki()); //月変計算月
		setParam(index++, dto.getGKanryou()); //月変完了
		setCommonParams(isInsert);
	}
	
}
